/**
 * 获取对象数据类型
 * @param value
 * @returns
 */
const GetType = (value) => Object.prototype.toString.call(value).slice(8, -1);

const IsType = (type) => (value) => type === GetType(value);

const IsArray = IsType("Array");

const IsNumber = IsType("Number");

const IsObject = IsType("Object");

const IsFun = IsType("Function");

const IsString = IsType("String");

const IsBoolean = IsType("Boolean");

export {
  GetType,
  IsType,
  IsArray,
  IsNumber,
  IsObject,
  IsFun,
  IsString,
  IsBoolean,
}